<?php
/*
* Configuration, translations and database converter
* Script upgrade Quick.Cart v4.x to v5.0
* Before run please read converter-read-me.txt
*/

error_reporting( E_ALL ^ E_NOTICE );
require 'core/libraries/trash.php';
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>Quick.Cart v5.x converter</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta name="Description" content="" />
  <meta name="Keywords" content="" />
  <meta name="Author" content="OpenSolution.org" />
  <style type="text/css">
    body,h1,h2,h3,h4,h5,h6,p,form,fieldset,img,td,th{margin:0;padding:0;border:0}
    body{background:#eae9e9;font:12px arial;color:#000;}
    a{color:#ca2222;text-decoration:underline;}
    a:hover{color:#000;text-decoration:underline;}

    input{font:11px arial;}
    .input, select{border:1px solid #666;font:11px arial;}
    .input:focus, select:focus{background:#ffebc1;}
    #converter{width:510px;margin:100px auto 0;padding:12px;background:#faf9f9;color:#fff;border:1px solid #dedbdb;-moz-border-radius:15px;border-radius:15px;}
    #body{padding:0 12px;background:#870707;-moz-border-radius:10px;border-radius:10px;}
    #logo{text-align:center;}
    #converter .description{padding:10px 0 5px;font-size:12px;}
    #converter form{margin-left:30px;padding-bottom:20px;font-size:14px;}
    #converter td{padding:5px;}
    #converter .input{width:200px;font-size:18px;}
    #converter .submit{background:#fff;font-size:13px;font-weight:bold;}
    #help{padding:10px 0 0 10px;}
    .msg{text-align:center;font-size:15px;font-weight:bold;padding:50px 0;}
    .msg a{color:#fff;}
    .msg a:hover{color:#000;}

    #converter form.step1 table{margin-top:10px;}
    #converter form.step2{font-size:12px;}
    #converter form.step2 label{margin-right:20px;}
    #converter form.step2 #options label{display:block;}
  </style>
</head>
<body>
  <div id="converter">
    <div id="body">
      <div id="logo"><a href="?p="><img src="http://opensolution.org/os/templates/img/logo_os_converter.jpg" alt="OpenSolution.org"/></a></div>    
<?php
if( isset( $_POST['sOldDir'] ) && !empty( $_POST['sOldDir'] ) ){
  $sOldDir = trim( $_POST['sOldDir'] );
  if( substr( $sOldDir, strlen( $sOldDir ) - 1 ) != '/' )
    $sOldDir .= '/';
  if( !is_dir( $sOldDir ) && !is_dir( $sOldDir.'/db' ) || !is_dir( $sOldDir.'/lang' ) || !is_dir( $sOldDir.'/config' ) ){
    $sOldDir = null;
  }
}

define( 'DB_NEW', 'database/' );
if( isset( $sOldDir ) )
  define( 'DB_OLD', $sOldDir );

if( isset( $_POST['aLangs'] ) && isset( $sOldDir ) ) {
  echo '<div class="msg">Operation ended successfully! :)<br /><br />Delete file "converter.php" from your server<br /><br />IGNORE ALL ERRORS STARTED WITH: Notice: Constant.<br />Other errors report on <a href="http://opensolution.org/Quick.Cart/forum/">forum &raquo;</a></div>';

  $iChmod = 0777;
  $aLangs = $_POST['aLangs'];

  if( isset( $_POST['iCopyConfig'] ) ){
    /*
    * Configuration convertion
    */
    convertConfig( $aLangs );
  }

  if( isset( $_POST['iCopyDatabase'] ) ){
    /*
    * Database convertion
    */
    foreach( $aLangs as $sLang ){
      convertDatabaseLang( $sLang );
    } // end foreach
    convertOrders( );
  }

  if( isset( $_POST['iCopyTranslations'] ) ){
    /*
    * Translations convertion
    */
    convertLangs( $aLangs );
  }
}
elseif( isset( $sOldDir ) ) {

  /*
  * All available translations
  */
  $aLangs = throwLangs( );
  if( isset( $aLangs ) && is_array( $aLangs ) && count( $aLangs ) > 0 ){
    echo '<form method="post" action="" name="form" class="step2">
    <div class="description">
      Choose languages which you want to be converted to new version:
    </div>
    <input type="hidden" name="sOldDir" class="input" value="'.$sOldDir.'" />';
    foreach( $aLangs as $sLang ){
      echo '<label><input type="checkbox" name="aLangs['.$sLang.']" value="'.$sLang.'" /> '.$sLang.'</label>';
    }
    echo '<br /><br />
      <div class="description">
        From old version (choose options):
      </div>
      <div id="options">
        <label><input type="checkbox" name="iCopyDatabase" value="1" checked="checked" /> copy database</label>
        <label><input type="checkbox" name="iCopyConfig" value="1" /> copy configuration</label>
        <label><input type="checkbox" name="iCopyTranslations" value="1" /> copy translations</label>
      </div>
      <br /><br />
      <div><input type="submit" value="next step &raquo;" class="submit" /></div>
    </form>';
  }
  else{
    echo '<div class="msg">Error: no language files</div>';
  }
}
else{
  echo '<form method="post" action="" name="form" class="step1">
    <div class="description">
      Thank you for download new version of Quick.Cart.<br /><br />
      Using this converter you can import data from Quick.Cart v4.x to v5.x:<br />
      - put converter script to new version main directory<br />
      - create directory for example "_old/" in new version directory and then type it below<br />
      - copy directories "db/", "config/", "lang/" from old version to that directory
    </div>
    <table>
      <tr><td>Old version directory:</td><td><input type="text" name="sOldDir" class="input" value="_old/" /></td></tr>
      <tr><td>&nbsp;</td><td><input type="submit" value="next step &raquo;" class="submit" /></td></tr>
    </table>
  </form>
  ';
}

?><?php
/*
* Functions 
*/
function throwLangs( ){
  foreach( new DirectoryIterator( DB_OLD.'lang/' ) as $oFileDir ) {
    if( $oFileDir->isFile( ) && strstr( $oFileDir->getFilename( ), '.php' ) ){
      $sLang = substr( $oFileDir->getFilename( ), 0, 2 );
      $aLangs[$sLang] = $sLang;
    }
  } // end foreach
  return $aLangs;
}

function convertLangs( $aLangs ){
  if( isset( $aLangs ) ){
    foreach( $aLangs as $sLang ){
      if( is_file( DB_OLD.'lang/'.$sLang.'.php' ) ){
        if( !is_file( DB_NEW.'translations/'.$sLang.'.php' ) ){
          copy( DB_NEW.'translations/en.php', DB_NEW.'translations/'.$sLang.'.php' );
          chmod( DB_NEW.'translations/'.$sLang.'.php', $GLOBALS['iChmod'] );
        }
        $aChangeLang = throwVariablesToChange( DB_OLD.'lang/'.$sLang.'.php', DB_NEW.'translations/'.$sLang.'.php', 'lang' );
        if( isset( $aChangeLang ) ){
          saveVariables( $aChangeLang, DB_NEW.'translations/'.$sLang.'.php', 'lang' );
        }
      }
    }
  }
}

function convertConfig( $aLangs ){
  if( isset( $aLangs ) ){
    foreach( $aLangs as $sLang ){
      if( is_file( DB_OLD.'config/lang_'.$sLang.'.php' ) ){
        if( !is_file( DB_NEW.'config/lang_'.$sLang.'.php' ) ){
          copy( DB_NEW.'config/lang_en.php', DB_NEW.'config/lang_'.$sLang.'.php' );
          chmod( DB_NEW.'config/lang_'.$sLang.'.php', $GLOBALS['iChmod'] );
        }
        $aChangeLang = throwVariablesToChange( DB_OLD.'config/lang_'.$sLang.'.php', DB_NEW.'config/lang_'.$sLang.'.php' );
        if( isset( $aChangeLang ) ){
          saveVariables( $aChangeLang, DB_NEW.'config/lang_'.$sLang.'.php' );
          if( isset( $aChangeLang['page_search'] ) ){
            $GLOBALS['page_search'][$sLang] = $aChangeLang['page_search'];
          }
        }
      }
    }
  }
  $aChangeGeneral = throwVariablesToChange( DB_OLD.'config/general.php', DB_NEW.'config/general.php' );
  if( isset( $aChangeGeneral ) ){
    saveVariables( $aChangeGeneral, DB_NEW.'config/general.php' );
  }
}

function convertDatabaseLang( $sLang ){
  if( !function_exists( 'pages' ) )
    include DB_OLD.'db/_pages.def.php';
  else
    $bAnotherCall = true;
  if( !function_exists( 'pages_ext' ) )
    include DB_OLD.'db/_pages_ext.def.php';
  if( !function_exists( 'pages_files' ) )
    include DB_OLD.'db/_pages_files.def.php';
  if( !function_exists( 'carriers' ) )
    include DB_OLD.'db/_carriers.def.php';
  if( !function_exists( 'carriers_payments' ) )
    include DB_OLD.'db/_carriers_payments.def.php';
  if( !function_exists( 'payments' ) )
    include DB_OLD.'db/_payments.def.php';
  if( !function_exists( 'products' ) )
    include DB_OLD.'db/_products.def.php';
  if( !function_exists( 'products_ext' ) )
    include DB_OLD.'db/_products_ext.def.php';
  if( !function_exists( 'products_files' ) )
    include DB_OLD.'db/_products_files.def.php';
  if( !function_exists( 'products_pages' ) )
    include DB_OLD.'db/_products_pages.def.php';
  include DB_NEW.'_fields.php';

  $aConvertAutomatic = Array( $sLang.'_pages_files' => 'pages_files', $sLang.'_products_files' => 'products_files' );
  if( !isset( $bAnotherCall ) ){
    #$aConvertAutomatic['banners'] = Array( 'banners', 'iBanner' );
    #$aConvertAutomatic['banners_stats'] = Array( 'banners_stats', 'iBanner' );
    #$aConvertAutomatic['users'] = Array( 'users', 'iUser' );
  }

  foreach( $aConvertAutomatic as $sFileName => $mValue ){
    if( is_file( DB_OLD.'db/'.$sFileName.'.php' ) ){
      $aFile = file( DB_OLD.'db/'.$sFileName.'.php' );
      $iCount = count( $aFile );
      if( is_array( $mValue ) ){
        $sFunction = $mValue[0];
        $sKey = $mValue[1];
      }
      else{
        $sFunction = $mValue;
        $sKey = null;
      }

      for( $i = 1; $i < $iCount; $i++ ){
        $aExp = $sFunction( explode( '$', $aFile[$i] ) );
        if( isset( $sKey ) )
          $aData[$aExp[$sKey]] = $aExp;
        else
          $aData[] = $aExp;

      } // end for

      file_put_contents( DB_NEW.$sFileName.'.php', '<?php exit; ?>'."\n".( isset( $aData ) ? serialize( $aData ) : null ) );
      unset( $aData, $aFile );
    }  
  } // end foreach

  if( is_file( DB_OLD.'db/'.$sLang.'_pages.php' ) && is_file( DB_OLD.'db/'.$sLang.'_pages_ext.php' ) ){
    $aPages = null;
    $aPagesFinal = null;

    $aFile = file( DB_OLD.'db/'.$sLang.'_pages_ext.php' );
    $iCount = count( $aFile );
    $aPages = null;
    for( $i = 1; $i < $iCount; $i++ ){
      $aExp = explode( '$', $aFile[$i] );
      $aPages[$aExp[0]] = pages_ext( $aExp );
    } // end for

    unset( $aFile );

    $aFile = file( DB_OLD.'db/'.$sLang.'_pages.php' );
    $iCount = count( $aFile );
    for( $i = 1; $i < $iCount; $i++ ){
      $aExp = explode( '$', $aFile[$i] );
      if( !is_numeric( $aExp[1] ) )
        $aExp[1] = 0;

      if( isset( $GLOBALS['page_search'][$sLang] ) && $aExp[0] == $GLOBALS['page_search'][$sLang] ){
        $aExp[9] = 1;
      }

      $aPagesFinal[] = array_merge( pages( $aExp ), $aPages[$aExp[0]] );
      $aPages[$aExp[0]] = null;
    } // end for

    file_put_contents( DB_NEW.$sLang.'_pages.php', '<?php exit; ?>'."\n".serialize( $aPagesFinal ) );
    unset( $aData, $aPages, $aPagesFinal, $aFile );
  }

  if( is_file( DB_OLD.'db/'.$sLang.'_products.php' ) && is_file( DB_OLD.'db/'.$sLang.'_products_ext.php' ) ){
    $aProducts = null;
    $aProductsFinal = null;

    $aFile = file(  DB_OLD.'db/'.$sLang.'_products_ext.php' );
    $iCount = count( $aFile );
    $aPages = null;
    for( $i = 1; $i < $iCount; $i++ ){
      $aExp = explode( '$', $aFile[$i] );
      $aProducts[$aExp[0]] = products_ext( $aExp );
    } // end for

    $aFile = file( DB_OLD.'db/'.$sLang.'_products.php' );
    $iCount = count( $aFile );
    for( $i = 1; $i < $iCount; $i++ ){
      $aExp = explode( '$', $aFile[$i] );
      if( isset( $aProducts[$aExp[0]] ) )
        $aProductsFinal[] = array_merge( products( $aExp ), $aProducts[$aExp[0]] );
    } // end for

    file_put_contents( DB_NEW.$sLang.'_products.php', '<?php exit; ?>'."\n".( isset( $aProductsFinal ) ? serialize( $aProductsFinal ) : '' ) );

    $aFile = file( DB_OLD.'db/'.$sLang.'_products_pages.php' );
    $aData = null;
    $iCount = count( $aFile );
    for( $i = 1; $i < $iCount; $i++ ){
      $aExp = explode( '$', $aFile[$i] );
      $aData[$aExp[0]][$aExp[1]] = (int) $aExp[1];
    } // end for

    file_put_contents( DB_NEW.$sLang.'_products_pages.php', '<?php exit; ?>'."\n".( isset( $aData ) ? serialize( $aData ) : '' ) );

    unset( $aData, $aProducts, $aProductsFinal, $aFile );
  }

  if( is_file( DB_OLD.'db/'.$sLang.'_carriers.php' ) && is_file( DB_OLD.'db/'.$sLang.'_carriers_payments.php' ) && is_file( DB_OLD.'db/'.$sLang.'_payments.php' ) ){
    $aCarriers = null;
    $aCarriersPayments = null;
    $aPayments = null;
    $iId = 1;

    $aFile = file(  DB_OLD.'db/'.$sLang.'_payments.php' );
    $iCount = count( $aFile );
    for( $i = 1; $i < $iCount; $i++ ){
      $aExp = explode( '$', $aFile[$i] );
      $aPayments[$aExp[0]] = payments( $aExp );
      $aAdd[$iId] = Array( 1, $aExp[0] );
      $iId++;
    } // end for

    $aFile = file( DB_OLD.'db/'.$sLang.'_carriers.php' );
    $iCount = count( $aFile );
    for( $i = 1; $i < $iCount; $i++ ){
      $aExp = explode( '$', $aFile[$i] );
      $aCarriers[$aExp[0]] = carriers( $aExp );
      $aAdd[$iId] = Array( 2, $aExp[0] );
      $iId++;
    } // end for

    $aFile = file( DB_OLD.'db/'.$sLang.'_carriers_payments.php' );
    $iCount = count( $aFile );
    for( $i = 1; $i < $iCount; $i++ ){
      $aExp = explode( '$', $aFile[$i] );
      $aCarriersPayments[$aExp[0]][$aExp[1]] = $aExp[2];
    } // end for

    if( isset( $aAdd ) ){
      foreach( $aAdd as $iId => $aValue ){
        $aData[$iId] = Array( 'iId' => $iId, 'iType' => $aValue[0], 'iStatus' => 1 );
        if( $aValue[0] == 1 ){
          $aData[$iId]['sName'] = $aPayments[$aValue[1]]['sName'];
          $GLOBALS['aPaymentsOrder'][$sLang][$aPayments[$aValue[1]]['iPayment']] = $iId;
        }
        else{
          $aData[$iId]['sName'] = $aCarriers[$aValue[1]]['sName'];
          $aData[$iId]['fPrice'] = $aCarriers[$aValue[1]]['fPrice'];
          if( isset( $aCarriersPayments[$aValue[1]] ) ){
            $aData[$iId]['aPayments'] = $aCarriersPayments[$aValue[1]];
          }
          $GLOBALS['aShippingOrder'][$sLang][$aCarriers[$aValue[1]]['iCarrier']] = $iId;
        }
      } // end foreach
      if( isset( $aData ) ){
        file_put_contents( DB_NEW.$sLang.'_payments_shipping.php', '<?php exit; ?>'."\n".serialize( $aData ) );
      }
    }

    unset( $aData, $aCarriers, $aCarriersPayments, $aPayments, $aFile, $aAdd );
  }
}

function convertOrders( ){
  global $aPaymentsOrder, $aShippingOrder;

  if( !function_exists( 'orders' ) )
    include DB_OLD.'db/_orders.def.php';
  if( !function_exists( 'orders_comments' ) )
    include DB_OLD.'db/_orders_comments.def.php';
  if( !function_exists( 'orders_products' ) )
    include DB_OLD.'db/_orders_products.def.php';
  if( !function_exists( 'orders_status' ) )
    include DB_OLD.'db/_orders_status.def.php';
  if( !function_exists( 'orders_temp' ) )
    include DB_OLD.'db/_orders_temp.def.php';

  if( is_file( DB_OLD.'db/orders.php' ) && is_file( DB_OLD.'db/orders_comments.php' ) && is_file( DB_OLD.'db/orders_products.php' ) && is_file( DB_OLD.'db/orders_status.php' ) && is_file( DB_OLD.'db/orders_temp.php' ) ){
    $aOrders = null;
    $aOrdersFinal = null;

    $rFile = fopen( DB_OLD.'db/orders.php', 'r' );
    $i = 0;
    while( !feof( $rFile ) ){
      $sFile = fgets( $rFile, 20000 );
      if( $i > 0 && !empty( $sFile ) ){
        $aExp = explode( '$', $sFile );
        $aOrders[$aExp[0]] = orders( $aExp );
      }
      $i++;
    } // end while
    fclose( $rFile );

    $rFile = fopen( DB_OLD.'db/orders_comments.php', 'r' );
    $i = 0;
    while( !feof( $rFile ) ){
      $sFile = fgets( $rFile, 20000 );
      if( $i > 0 && !empty( $sFile ) ){
        $aExp = explode( '$', $sFile );
        $aOrdersExt[$aExp[0]] = orders_comments( $aExp );
      }
      $i++;
    } // end while
    fclose( $rFile );

    $rFile = fopen( DB_OLD.'db/orders_status.php', 'r' );
    $i = 0;
    while( !feof( $rFile ) ){
      $sFile = fgets( $rFile, 20000 );
      if( $i > 0 && !empty( $sFile ) ){
        $aExp = explode( '$', $sFile );
        $aOrdersStatus[$aExp[0]][] = Array( 0 => (int) $aExp[2], 1 => (int) $aExp[1] );
      }
      $i++;
    } // end while
    fclose( $rFile );

    file_put_contents( DB_NEW.'orders.php', '<?php exit; ?>'."\n" );
    if( isset( $aOrders ) ){
      foreach( $aOrders as $iOrder => $aData ){
        unset( $aData['sIp'], $aData['iCarrier'], $aData['iPayment'], $aData['sCarrierName'], $aData['fCarrierPrice'], $aData['sPaymentName'], $aData['mPaymentPrice'] );
        file_put_contents( DB_NEW.'orders.php', serialize( $aData )."\n", FILE_APPEND );  
      } // end foreach
    }

    file_put_contents( DB_NEW.'orders_ext.php', '<?php exit; ?>'."\n" );  
    if( isset( $aOrdersExt ) ){
      foreach( $aOrdersExt as $iOrder => $aData ){
        if( isset( $aOrders[$iOrder] ) ){
          $aSave = null;
          $aSave['iOrder'] = (int) $aData['iOrder'];
          if( isset( $aPaymentsOrder[$aOrders[$iOrder]['sLanguage']] ) && isset( $aPaymentsOrder[$aOrders[$iOrder]['sLanguage']][$aOrders[$iOrder]['iPayment']] ) )
            $aSave['iPayment'] = $aPaymentsOrder[$aOrders[$iOrder]['sLanguage']][$aOrders[$iOrder]['iPayment']];
          if( isset( $aShippingOrder[$aOrders[$iOrder]['sLanguage']] ) && isset( $aShippingOrder[$aOrders[$iOrder]['sLanguage']][$aOrders[$iOrder]['iCarrier']] ) ){
            $aSave['iShipping'] = $aShippingOrder[$aOrders[$iOrder]['sLanguage']][$aOrders[$iOrder]['iCarrier']];
          }

          $aSave['mShipping'] = $aOrders[$iOrder]['sCarrierName'];
          $aSave['fShippingPrice'] = $aOrders[$iOrder]['fCarrierPrice'];
          $aSave['mPayment'] = $aOrders[$iOrder]['sPaymentName'];
          $aSave['mPaymentPrice'] = $aOrders[$iOrder]['mPaymentPrice'];
          $aSave['sIp'] = $aOrders[$iOrder]['sIp'];

          unset( $aSave['sComment'] );

          if( !empty( $aData['sComment'] ) )
            $aSave['sComment'] = $aData['sComment'];

          if( isset( $aOrdersStatus[$iOrder] ) )
            $aSave['aStatuses'] = $aOrdersStatus[$iOrder];


          file_put_contents( DB_NEW.'orders_ext.php', serialize( $aSave )."\n", FILE_APPEND );
        }
      } // end foreach
    }

    unset( $aOrdersExt, $aOrdersStatus );

    $rFile = fopen( DB_OLD.'db/orders_products.php', 'r' );
    $i = 0;
    while( !feof( $rFile ) ){
      $sFile = fgets( $rFile, 20000 );
      if( $i > 0 && !empty( $sFile ) ){
        $aExp = explode( '$', $sFile );
        if( isset( $aOrders[$aExp[1]] ) ){
          $aOrdersProducts[$aExp[0]] = orders_products( $aExp );
        }
      }
      $i++;
    } // end while
    fclose( $rFile );

    file_put_contents( DB_NEW.'orders_products.php', '<?php exit; ?>'."\n" );
    if( isset( $aOrdersProducts ) ){
      foreach( $aOrdersProducts as $iElement => $aData ){
        file_put_contents( DB_NEW.'orders_products.php', serialize( $aData )."\n", FILE_APPEND );
      } // end foreach
    }

    unset( $aData );
    $aFile = file( DB_OLD.'db/orders_temp.php' );
    $iCount = count( $aFile );
    for( $i = 1; $i < $iCount; $i++ ){
      $aExp = orders_temp( explode( '$', $aFile[$i] ) );

      $aData[$aExp['iCustomer']][$aExp['iProduct']] = Array( 'iQuantity' => (int) $aExp['iQuantity'], 'fPrice' => $aExp['fPrice'], 'sName' => $aExp['sName'] );
    } // end for
    if( isset( $aData ) ){
      file_put_contents( DB_NEW.'orders_temp.php', '<?php exit; ?>'."\n".serialize( $aData )."\n" );
    }
  }
}

function saveVariables( $aForm, $sFile, $sVariable = 'config' ){
  $aFile = file( $sFile );
  $iCount = count( $aFile );
  $rFile = fopen( $sFile, 'w' );

  for( $i = 0; $i < $iCount; $i++ ){
    foreach( $aForm as $sKey => $sValue ){
      if( preg_match( '/'.$sVariable."\['".$sKey."'\]".' /', $aFile[$i] ) && strstr( $aFile[$i], '=' ) ){
        if( !is_bool( $sValue ) && !is_numeric( $sValue ) && !is_array( $sValue ) && !strstr( $sValue, 'Array(' ) ){
          $sValue = changeSpecialChars( $sValue );
          $sValue = str_replace( '"', '&quot;', $sValue );
          $sValue = stripslashes( $sValue );
        }
        
        if( is_array( $sValue ) ){
          $aFile[$i] = "\$".$sVariable."['".$sKey."'] = ".str_replace( "\n", '', var_export( $sValue, true ) ).";\n";
        }
        elseif( ( is_numeric( $sValue ) || preg_match( '/^(true|false|null)$/', $sValue ) == true ) && !preg_match( '/0[0-9]+/', $sValue ) ){
          $aFile[$i] = "\$".$sVariable."['".$sKey."'] = ".$sValue.";\n";
        }
        elseif( is_bool( $sValue ) ){
          if( $sValue === true )
            $aFile[$i] = "\$".$sVariable."['".$sKey."'] = true;\n";
          else
            $aFile[$i] = "\$".$sVariable."['".$sKey."'] = false;\n";
        }
        else
          $aFile[$i] = "\$".$sVariable."['".$sKey."'] = \"".$sValue."\";\n";
      }
      else{
        if( strstr( $aFile[$i], 'aMenuTypes' ) && strstr( $aFile[$i], '=' ) && strstr( $aFile[$i], 'Array' ) && isset( $GLOBALS['aMenuTypes'] ) ){
          $aFile[$i] = '$aMenuTypes = '.str_replace( "\n", '', var_export( $GLOBALS['aMenuTypes'], true ) ).";\n";
        }
      }
    } // end foreach

    fwrite( $rFile, $aFile[$i] );

  } // end for
  fclose( $rFile );
}

function throwVariablesToChange( $sFileOld, $sFileNew, $sVariable = 'config' ){
  include $sFileOld;
  $aOld = $$sVariable;
  include $sFileNew;
  $aNew = $$sVariable;
  foreach( $aNew as $sKey => $sValue ){
    if( isset( $aOld[$sKey] ) && $aOld[$sKey] != $sValue && !is_array( $aOld[$sKey] ) && !preg_match( '/dir|config|version/i', $sKey ) ){
      $aChange[$sKey] = $aOld[$sKey];
    }
  } // end foreach

  if( isset( $aOld['page_search'] ) ){
    $aChange['page_search'] = $aOld['page_search'];
  }

  if( isset( $aOld['pages_images_sizes'] ) ){
    $aChange['images_sizes'] = $aOld['pages_images_sizes'];
  }
  if( isset( $aOld['default_lang'] ) ){
    $aChange['admin_lang'] = $aOld['default_lang'];
  }
  if( isset( $aMenuTypes ) && count( $aMenuTypes ) > 4 ){
    $GLOBALS['aMenuTypes'] = $aMenuTypes;
  }  
  if( isset( $aChange ) )
    return $aChange;
}
?>